package cn.com.qmth.examcloud.core.basic.api.bean;

import cn.com.qmth.examcloud.commons.web.cloud.api.JsonSerializable;
import cn.com.qmth.examcloud.commons.web.helpers.tree.TreeNode;
import cn.com.qmth.examcloud.commons.web.jpa.JpaEntity;

/**
 * 权限信息
 *
 * @author WANGWEI
 * @date 2018年5月23日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class PrivilegeInfo extends JpaEntity implements JsonSerializable, TreeNode {

	private static final long serialVersionUID = -8828760710678965127L;

	/**
	 * 权限ID
	 */
	private Long id;

	/**
	 * 权限码
	 */
	private String code;

	/**
	 * 权限名称
	 */
	private String name;

	/**
	 * 父权限ID
	 */
	private Long parentId;

	/**
	 * 组(权限分组,同一组的权限构成权限树)
	 */
	private Long groupId;

	/**
	 * 是否有权限
	 */
	private boolean hasPrivilege;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Long getParentId() {
		return parentId;
	}

	public void setParentId(Long parentId) {
		this.parentId = parentId;
	}

	public Long getGroupId() {
		return groupId;
	}

	public void setGroupId(Long groupId) {
		this.groupId = groupId;
	}

	public boolean isHasPrivilege() {
		return hasPrivilege;
	}

	public void setHasPrivilege(boolean hasPrivilege) {
		this.hasPrivilege = hasPrivilege;
	}

	@Override
	public String getTreeId() {
		if (null == this.id) {
			return null;
		}
		return String.valueOf(this.id);
	}

	@Override
	public void setTreeId(String treeId) {
		if (null == treeId) {
			this.id = null;
		}
		this.id = Long.parseLong(treeId);
	}

	@Override
	public String getTreeName() {
		if (null == this.name) {
			return null;
		}
		return String.valueOf(this.name);
	}

	@Override
	public void setTreeName(String treeName) {
		this.name = treeName;
	}

	@Override
	public String getParentTreeId() {
		if (null == this.parentId) {
			return null;
		}
		return String.valueOf(this.parentId);
	}

	@Override
	public void setParentTreeId(String parentTreeId) {
		if (null == parentTreeId) {
			this.parentId = null;
		}
		this.parentId = Long.parseLong(parentTreeId);
	}

}
